/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the LabelValueResponseInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &LabelValueResponseInner{}

// LabelValueResponseInner struct for LabelValueResponseInner
type LabelValueResponseInner struct {
	Label *string `json:"label,omitempty"`
	Value *string `json:"value,omitempty"`
}

// NewLabelValueResponseInner instantiates a new LabelValueResponseInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewLabelValueResponseInner() *LabelValueResponseInner {
	this := LabelValueResponseInner{}
	return &this
}

// NewLabelValueResponseInnerWithDefaults instantiates a new LabelValueResponseInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewLabelValueResponseInnerWithDefaults() *LabelValueResponseInner {
	this := LabelValueResponseInner{}
	return &this
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *LabelValueResponseInner) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *LabelValueResponseInner) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *LabelValueResponseInner) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *LabelValueResponseInner) SetLabel(v string) {
	o.Label = &v
}

// GetValue returns the Value field value if set, zero value otherwise.
func (o *LabelValueResponseInner) GetValue() string {
	if o == nil || IsNil(o.Value) {
		var ret string
		return ret
	}
	return *o.Value
}

// GetValueOk returns a tuple with the Value field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *LabelValueResponseInner) GetValueOk() (*string, bool) {
	if o == nil || IsNil(o.Value) {
		return nil, false
	}
	return o.Value, true
}

// HasValue returns a boolean if a field has been set.
func (o *LabelValueResponseInner) HasValue() bool {
	if o != nil && !IsNil(o.Value) {
		return true
	}

	return false
}

// SetValue gets a reference to the given string and assigns it to the Value field.
func (o *LabelValueResponseInner) SetValue(v string) {
	o.Value = &v
}

func (o LabelValueResponseInner) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o LabelValueResponseInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.Value) {
		toSerialize["value"] = o.Value
	}
	return toSerialize, nil
}

type NullableLabelValueResponseInner struct {
	value *LabelValueResponseInner
	isSet bool
}

func (v NullableLabelValueResponseInner) Get() *LabelValueResponseInner {
	return v.value
}

func (v *NullableLabelValueResponseInner) Set(val *LabelValueResponseInner) {
	v.value = val
	v.isSet = true
}

func (v NullableLabelValueResponseInner) IsSet() bool {
	return v.isSet
}

func (v *NullableLabelValueResponseInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableLabelValueResponseInner(val *LabelValueResponseInner) *NullableLabelValueResponseInner {
	return &NullableLabelValueResponseInner{value: val, isSet: true}
}

func (v NullableLabelValueResponseInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableLabelValueResponseInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
